Welcome!

Welcome! Thanks for using Total .NET SourceBook. We hope that it helps you create better .NET Solutions faster than ever. This help file is designed to provide you with the information you need to get up and running quickly.

Key Topics

  • About Total .NET SourceBook

  • Running the Program

  • Adding New Items

  • Launching the Add-In

  • Getting Code into Your Project

  • Getting Code into Total .NET SourceBook

  • Code Webservice

  • Support Resources

More Tools to Help You

Visit www.fmsinc.com/dotnet for the latest information on our complete line of .NET Developer solutions. Get up-to-date product information, tips and tricks, or subscribe to our email newsletter for .NET development.

Contact FMS

  • Web Site: www.fmsinc.com

  • For more information: info@fmsinc.com

  • Technical Support: support@fmsinc.com

  • Product Updates: www.fmsinc.com/free/updates


About Total .NET SourceBook

Total .NET SourceBook is the ultimate code library for .NET developers, teams, and enterprises. It provides the best collection of ready-to-use code, snippets, classes, how-to’s, and articles. It also allows you to manage your own code and share knowledge within a team by using the fully searchable code repository.

Every level of developer will benefit from using Total .NET SourceBook. Beginners can use Total .NET SourceBook to get up to speed quickly by learning from the tips, articles, how-to’s, and examples. Experts can use the vast array of advanced concepts to learn new techniques, and will save time by using fully tested and ready-to-run code. And because the library code is open and available for modification, experts can customize the code to meet their specific needs.

You can even use Total .NET SourceBook to store your own code in one centralized, searchable location. No more rewriting code, or digging through old projects to find it—it’s all in one place! And because Total .NET SourceBook is completely multi-user capable, your entire development team can collaborate to share code, tips, and ideas.

See Also

  • Program Highlights

  • New Features

  • Visit our Web Site


Program Highlights

Total .NET SourceBook is a complete collection of ready-to-use .NET programming code, with C# and Visual Basic .NET versions. A wide range of .NET programming areas is covered, and new code keeps coming with your subscription to the FMS Code Webservice.

Total .NET SourceBook provides both a full-featured standalone Code Explorer, and an integrated Visual Studio .NET Add-In.

Code Explorer

The standalone Code Explorer makes it easy to find, organize, edit, and manage code. Implemented as a native .NET Windows Forms application, the Total .NET SourceBook Code Explorer is a complete code and knowledge management solution for developers.

Total .NET SourceBook Code Explorer

Use the Code Explorer to:

· View, edit, and delete existing code items.

· Add new code items and code databases.

· Perform advanced searches on code databases.

· Export code to a file or to the clipboard.

· Get new and updated code from the Code Webservice.

Add-In

The integrated Visual Studio .NET Add-In provides you with easy access to Total .NET SourceBook code while you’re working on your project. The Add-In displays as a toolwindow right inside of your development environment:

Total .NET SourceBook Add-In Toolwindow

Use the Add-In to:

· Insert individual items or entire folders from the Total .NET SourceBook database into your project.

· Insert code from Total .NET SourceBook into existing files in your project.

· Drag code from of your project into the Total .NET SourceBook repository.

· View, edit, and delete existing code items and notes.

· Perform text searches within code items.

See Also

  • About Total .NET SourceBook

  • New Features

  • Visit our Web Site


New Features

The first version of Total .NET SourceBook for Visual Studio .NET 2002 was released in November 2002, and a new version for Visual Studio .NET 2003 was released the following February. Since its release, Total .NET SourceBook has received a multitude of outstanding reviews and awards, and has been extremely popular within the .NET development community.

With the release of Visual Studio .NET 2005, we are pleased to release a new version that incorporates many of features requested over the years. The latest version of Total .NET SourceBook includes the following new features and enhancements:

Support for Visual Studio .NET 2005

Total .NET SourceBook 2005 includes support for Visual Studio .NET 2005. The Total .NET SourceBook Add-In is integrated into the Visual Studio .NET 2005 development environment, and code is included for the new framework.

Total .NET SourceBook version 1.1 and version 1.0 are still available for integration with Visual Studio .NET 2003 and 2002, respectively.

New Code for .NET 2.0 Framework

Total .NET SourceBook 2005 includes new code, articles, tutorials, and tips for the .NET 2.0 Framework. Quickly get up-to-speed on the latest features and techniques in Visual Studio 2005. Plus, more code keeps coming with your subscription to the FMS Code Webservice!

Version Tag for Code

The new “Version” tag for code items lets you distinguish between items that are relevant to different versions of the .NET Framework. This feature lets you keep code that is optimized for different .NET versions, and always know where the code should be used. You can even search for items by version, making it easy to find exactly what you need.

Support for Code Behind Forms

Total .NET SourceBook allows you to link Web Forms and the code behind them, and Windows Forms and their designer code. This makes it easier than ever to export code items to your project.

Easier Code Insertion using the Add-In

You can now use the Add-In to insert code into your project without having a code editor open, or batch insert all items in a folder. Simply select an item or folder, and click the “Insert in Project” button. When you insert entire folders, forms and their “Code Behind” classes are even automatically linked in Visual Studio.

Enhanced Code Display

Code is now displayed in a much richer interface, with collapsible regions and syntax highlighting for HTML, XML, and ASP.NET code. New right-click shortcuts are available to comment or uncomment code, indent or outdent lines, and more.

Insert Images in Notes

Item Notes now support inserting images. This feature lets store example pictures and screenshots right with your code.

New Code Types

Two new Code Types are available for Total .NET SourceBook items: WinForm and Configuration.

Backward Compatible

Total .NET SourceBook 2005 supports code databases from all previous versions of Total .NET SourceBook.

See Also

  • About Total .NET SourceBook

  • Program Highlights

  • Visit our Web Site


Visit our Web Site

FMS is constantly developing new and better developer solutions. Total .NET SourceBook is part of our complete line of products designed specifically for the .NET developer. Please take a moment to visit us online at www.fmsinc.com/dotnet to find out about new products and updates.

Product Announcements and Press Releases

Read the latest information on new products, new versions, and future products. Press releases are available the same day they are sent to the press. Sign up in our Feedback section to have press releases automatically sent to you via email.

Product Descriptions and Demos

Detailed descriptions for all of our products are available. Each product has its own page with information about features and capabilities. Demo versions for most of our products are also available.

Product Registration

Register your copy of Total .NET SourceBook online. Be sure to select the email notification option so you can be contacted when updates are available or news is released. You must be registered to receive technical support.

Product Updates

FMS is committed to quality software. When we find problems in our products, we fix them and post the new builds on our web site. Check our Product Updates page in the Technical Support area to make sure you’re using the latest build of Total .NET SourceBook.

Utilities and Free Software

Download free demos and utilities, including add-ins and developer tools.

Technical Papers

FMS personnel often speak at conferences and write magazine articles, papers, and books. Copies and portions of this information are available to you online. Learn about our latest ideas and tricks for developing more effectively.

Newsgroups

Share your experiences, learn from others, and ask your questions in our virtual community. Visit our newsgroups at:

www.fmsinc.com/support/newsgrp.htm

Or see our web site for additional instructions.

Links to Other Development Sites

Jump to other locations, including newsgroups, user groups, and other sites with news, techniques, and related services.

See Also

  • About Total .NET SourceBook

  • Program Highlights

  • New Features


Installing the Program

Total .NET SourceBook is installed using an automated Windows Installer setup program. To install Total .NET SourceBook, follow these steps:

1. Locate and run the setup program.

2. When prompted, enter your registration information and product key (serial number).

3. Specify the destination directory for the files.

4. Be sure to read the README.HTM file for any late breaking news that is not included in this help file.

When you install the product, be sure to enter your correct serial number, user name, and organization. This information is required for your Code Webservice Subscription to work properly.

See Also

  • System Requirements

  • Check for Updates

  • Uninstalling the Program


System Requirements

Total .NET SourceBook has the following system requirements:

· Microsoft Visual Studio .NET 2005

· Operating system, processor, and memory required to successfully run Microsoft Visual Studio .NET 2005

· Approximately 25 MB of free disk space.
Additional disk space is needed as you add items to the Total .NET SourceBook code database.

See Also

  • Installing the Program

  • Check for Updates

  • Uninstalling the Program


Check for Updates

After Installing the Program, you should check the FMS website to see if any product updates are available. To do this visit the Product updates section of the FMS Technical Support Site:

www.fmsinc.com/support

You should also check the FMS Code Webservice to download the latest code.

See Also

  • System Requirements

  • Installing the Program

  • Uninstalling the Program


Uninstalling the Program

If you need to uninstall Total .NET SourceBook, follow these steps:

1. From the Windows Start Menu, select Control Panel.

2. From the Control Panel window, select Add/Remove Programs.

3. Select FMS Total .NET SourceBook from the list of installed programs, and click the "Change/Remove" button.

4. Follow the onscreen prompts to uninstall the product.

Note that uninstalling Total .NET SourceBook does not remove any of your code databases, such as FMSCode2.MDB or code databases you have created.

See Also

  • System Requirements

  • Installing the Program

  • Check for Updates


Running the Program

To open the SourceBook Code Explorer, run FMS.SourceBook.exe from your installation directory or from the shortcut in the Windows Start menu:

Start, Programs, FMS .NET Suite, Total .NET SourceBook, SourceBook

When you run the program for the first time, the FMS code database (FMSCode2.MDB) is created in the My Documents folder of the Windows user who is logged in.

If you need to recover the original version of the database, follow these steps:

1. Locate FMSCode2.MDB in the “Resources” subfolder of the Total .NET SourceBook installation directory.

2. Copy (do not move) FMSCode2.MDB to the desired location (e.g. your My Documents folder).

3. Remove the “Read-Only” attribute for the new database by right-clicking on the new database choosing Properties, and un-checking the “Read-only” check box.

4. Load the new database using the Code Explorer, as explained in Managing Multiple Code Databases.

See Also

  • Start Page

  • Menu and Toolbar

  • Configuring Settings

  • Treeview

  • Details Pane

  • Search Results


Start Page

When you load the Code Explorer, the Start Page appears:

Total .NET SourceBook Start Page

The Start Page provides links to common tasks and help topics, displays the available Code Webservice updates, and shows late-breaking development news and resources.

By default, the Start Page appears every time you run the Code Explorer. If you do not want to see the Start Page when you start the program, disable this option on the Settings form.

See Also

  • Running the Program

  • Menu and Toolbar

  • Configuring Settings

  • Treeview

  • Details Pane

  • Search Results


Menu and Toolbar

Total .NET SourceBook provides many features that make it easy to find and manage code. All of these features are available from the Code Explorer menu, and shortcuts for many options are available from the toolbar:

Code Explorer Menu and Toolbar

The following menus are available:

  • File Menu

  • Edit Menu

  • View Menu

  • Search Menu

  • Tools Menu

  • Help Menu

See Also

  • Start Page

  • Treeview

  • Configuring Settings

  • Details Pane

  • Search Results


File Menu

Select "File" from the Menu Bar to see common file tasks:

File Menu

* | Open Database : Opens a code database
* | Close Database: Closes the code database that has focus in the treeview
* | New Database: Creates a new code database
* | Import SourceBook XML: Imports a code item or folder from an XML file into the folder or database that has focus in the treeview
 | Import File: Imports the contents of a file into the folder or database that has focus in the treeview
* | Export SourceBook XML: Exports the folder or code item that has focus to an XML file
 | Export File: Exports the code item that has focus to a text file, with options to include multiple language versions, notes, and other fields
 | Recent Databases: Displays a list of recent code databases
 | Exit: Closes Total .NET SourceBook

See Also

  • Menu and Toolbar

    • Edit Menu

    • View Menu

    • Search Menu

    • Tools Menu

    • Help Menu


Edit Menu

Select "Edit" from the Menu Bar to see common Edit tasks:

Edit Menu

* | New Item: Creates a new code item in the database or folder that has focus in the treeview
* | New Folder : Creates a new folder in the database or folder that has focus in the treeview
* | Edit Item: Opens the edit form for the folder or code item that has focus in the treeview
* | Delete Item : Deletes the folder or code item that has focus in the treeview

See Also

  • Menu and Toolbar

    • File Menu

    • View Menu

    • Search Menu

    • Tools Menu

    • Help Menu


View Menu

Select "View" from the Menu Bar to see common View tasks:

View Menu

* | Expand All: Expands all nodes in the treeview
* | Collapse All: Collapses all nodes in the treeview
* | Refresh Database: Refreshes the database that has focus in the treeview to ensure that all items are up-to-date. Use the Refresh menu item when multiple developers are using the same database, or when you are making changes through the Total .NET SourceBook add-in.

See Also

  • Menu and Toolbar

    • File Menu

    • Edit Menu

    • Search Menu

    • Tools Menu

    • Help Menu


Search Menu

Select "Search" from the Menu Bar to see common Search tasks:

Search Menu

* | Local Database(s): Opens the search form, which allows you to search local databases
* | Code Webservice: Displays the recent items available from the FMS Code Webservice

See Also

  • Menu and Toolbar

    • File Menu

    • Edit Menu

    • View Menu

    • Tools Menu

    • Help Menu


Tools Menu

Select "Tools" from the Menu Bar to see common tools:

Tools Menu

Settings: Opens the Settings form, which includes options for application behavior, default values, and Code Webservice connection.

Database Maintenance: Provides tools for managing code databases.

See Also

  • Menu and Toolbar

    • File Menu

    • Edit Menu

    • View Menu

    • Search Menu

    • Help Menu


Help Menu

Select "Help" from the Menu Bar to see common Help tasks:

Help Menu

Contents: Displays the help contents

Index: Displays the help index

FMS on the Web: Takes you to the FMS web site: www.fmsinc.com

About: Displays license, version, and copyright information for Total .NET SourceBook

See Also

  • Menu and Toolbar

    • File Menu

    • Edit Menu

    • View Menu

    • Search Menu

    • Tools Menu


Configuring Settings

Total .NET SourceBook contains several options that allow you to customize the application’s behavior, default values, and Code Webservice connection. These options are available on the Settings form.

To open the Settings form, choose Tools, Settings from the Code Explorer menu.

Settings Form

The following tabs are available:

  • General Tab

  • User Info Tab

  • Web Service Tab

See Also

  • Start Page

  • Menu and Toolbar

  • Configuring Settings

  • Treeview

  • Details Pane

  • Search Results


General Tab

The General tab of the Settings form includes two options for the application’s behavior:

Settings Form, General Tab

Open last used databases on startup
If this option is checked, Total .NET SourceBook remembers which databases you have open, and loads them the next time you start the application.

If this option is not checked, Total .NET SourceBook does not open any databases at startup. This allows the application to load faster, but you must browse for and open the desired database.

Always start in Start Page
If this option is checked, the Start Page is displayed every time you open Total .NET SourceBook. If this option is not checked, Total .NET SourceBook sets focus to the last-used database by default.

Default Code Version
This option lets you specify the default version to use when you create a new folder or item. The version is displayed on the Details tab of the Item Editor. The version that you select on the Settings form is used by default, but it can be overridden on a case-by-case basis.

See Also

  • Configuring Settings

    • User Info Tab

    • Web Service Tab


User Info Tab

The User Info tab of the Settings form allows you to specify the information to use by default when you create new code items:

Settings Form, User Info Tab

When you create new items (folders, code items, articles, etc.), Total .NET SourceBook allows you to specify the Developer Name, Email Address, and Copyright Info for the item. This is useful in several situations, including:

· When you are using Total .NET SourceBook in a multi-user environment where it is important to know who created code.

· When you are exporting code from your installation of Total .NET SourceBook for other Total .NET SourceBook users and you want to maintain your contact and copyright information.

By default, new items use the values that you specify on the User Info tab of the Settings form. However, these values can be overridden on a case-by-case basis by editing the values on the Details tab.

See Also

  • Configuring Settings

    • General Tab

    • Web Service Tab


Web Service

The Web Service tab of the Settings form lets you configure settings to use when connecting to the FMS Code Webservice:

Settings Form, Web Service Tab

Proxy User Name and Proxy Password
If you go trough a Proxy server to access the Internet, enter the User Name and Password of a user with the appropriate permissions.

Code Webservice Date
Every time you download code from the FMS Code Webservice, Total .NET SourceBook updates this date. This keeps you from retrieving the same code more than once—only code posted after this date will be retrieved. If you want to retrieve earlier content, use this field to override the Code Webservice date.

See Also

  • Configuring Settings

    • General Tab

    • User Info Tab


Treeview

The Treeview provides a visual representation of the items in your code database. It allows you to view and edit multiple code databases, and offers an easy way to organize your code:

Treeview

More Information

  • Code Items

  • Organizing the Code

  • Right-Click Menu

See Also

  • Start Page

  • Menu and Toolbar

  • Configuring Settings

  • Details Pane

  • Search Results


Code Items

Total .NET SourceBook provides you with the flexibility to store all of your important .NET resources in one place. The following icons help you differentiate between types of items in the treeview:

 | Class: A ready-to-run .NET class.
 | Code: Generic ready-to-run code in the form of a method, procedure, subroutine, etc.
 | Configuration: An XML-formatted file that provides settings for ASP.NET or WinForms applications.
 | Module: A Visual Basic .NET module.
 | Snippet: A fragment of code that illustrates a programming concept, but is not ready-to-run. Typically, snippets are bits of code that are to be integrated into a new or existing class, method, or procedure.
 | How-To: A combination of code and notes that illustrate the general principals of a programming task.
 | Item: Any generic item of information that does not fit into other categories.
 | WebForm: A .NET Web Form. Web Form items support Code Behind classes.
 | WinForm: A .NET Windows Form. Win Form items support Code Behind classes.
 | Article: An item comprised mostly or entirely of notes, with little or no code.
 | XML: Any XML file.
* | Other: Any other item that does not fit into other categories.

See Also

  • Treeview

    • Organizing the Code

    • Right-Click Menu


Organizing Your Code

Total .NET SourceBook allows you to organize the code in the treeview to suit your needs and preferences. You can drag and drop code items to move or copy items into new locations. Just click on the item to move, and drag it into the new location.

The status bar at the bottom of the Code Explorer displays an appropriate message if you attempt to drag and drop to an invalid location. Items and folders can be dragged into folders and databases. Databases cannot be dragged.

When you drop the item, the drag/drop menu appears:

Drag/Drop Menu

Note that there is no Undo for drag and drop operations. To move an item back to its original location, you must drag it back.

See Also

  • Treeview

    • Code Items

    • Right-Click Menu


Right-Click Menu

Use the treeview right-click menu as a shortcut to access many of the useful options available in the product:

Treeview Right-Click Menu

* New Item : Creates a new code item in the database or folder that has focus in the treeview

* New Folder : Creates a new folder in the database or folder that has focus in the treeview

* Edit Item: Opens the edit form for the folder or code item that has focus in the treeview

* Delete Item : Deletes the folder or code item that has focus in the treeview

* Import SourceBook XML: Imports a code item or folder from an XML file into the folder or database that has focus in the treeview

Import File : Imports the contents of a file into the folder or database that has focus in the treeview

* Export SourceBook XML : Exports the folder or code item that has focus to an XML file

Export File : Exports the code item that has focus to a text file, with options to include multiple language versions, notes, and other fields

* Expand All: Expands all nodes in the treeview

* Collapse All: Collapses all nodes in the treeview

Expand Node: Expands the node that currently has focus in the treeview

Collapse Node: Collapses the node that currently has focus in the treeview

See Also

  • Treeview

    • Code Items

    • Organizing the Code


Details Pane

The details pane appears to the right of the treeview, and shows the item’s information, code, notes, and details:

Details Pane

See Also

  • Start Page

  • Menu and Toolbar

  • Configuring Settings

  • Treeview

  • Search Results


Information Section

The information section of the Details Pane appears at the top of the details pane:

Details Pane, Information Section

The information section shows an overview of the item, including name, type, description, and author. It also provides options to show or hide the notes, and to show or hide the details.

See Also

  • Details Pane

    • Code Tabs

    • Notes

    • Details


Code Tabs

The Code Tabs on the Details Pane display the item's code.

Since the Microsoft .NET platform supports many languages, Total .NET SourceBook is designed to be versatile enough to support them all. The code that comes with the product includes both C# and Visual Basic .NET versions, and the program in general supports multiple languages.

The code tabs appear below the information section:

Details Pane, Code Tabs

The code tabs display the item’s code, and allow you to organize your code by language. Tabs containing code are displayed with the [image] icon, so you can easily identify where your code is stored.

When working with code, you may want to consider hiding the notes and/or details sections to view the maximum amount of code in the window. To hide these sections, use the buttons found in the Information Section, at the top of the Details Pane.

Right-Click Context Menu

Right-click on the code tabs to access several useful code options, including:

· Copy | · Select All
· Outlining | · Bookmarks
· Print | · Print Preview
· Find/Replace | · Go To…
· Highlighting Style Editor | · Edit

Note that options that only apply in edit mode are disabled in this right-click context menu. For example, since you can only comment and uncomment code while in edit mode, these options are disabled.

See Item Code for details about the available options.

See Also

  • Details Pane

    • Information Section

    • Notes

    • Details

  • Item Code


Notes

The notes section of the Details Pane appears below the code tabs:

Details Pane, Notes

The notes section shows information pertaining to the code item. To hide the notes, click the “Hide Notes” button in the information section.

See Also

  • Details Pane

    • Information Section

    • Code Tabs

    • Details

  • Item Notes


Details

The details section of the Details Pane appears at the bottom of the Details Pane:

Details Pane, Details

The details section displays author email, copyright information, created and modified dates, source, item GUID (a unique ID for each item), and Version. To hide the details, click the “Hide Details” button in the information section.

If you are not concerned with viewing the Details section at all times, consider hiding it to allow more room for the Code Tabs and the Notes.

See Also

  • Details Pane

    • Information Section

    • Code Tabs

    • Notes

  • Item Details


Search Results

The bottom of the main form shows the results of the last search you performed:

Search Results

The search grid shows the item icon, name, description, and database for each item found. Click on any row in the results to jump to that item in the treeview.

To perform a quick text search, type the search value in the “Search for” field below the treeview:

For advanced options, click the Advanced Search link.

See Also

  • Start Page

  • Menu and Toolbar

  • Configuring Settings

  • Treeview

  • Details Pane

  • Searching Code Databases


The Importance of Backups

If you use Total .NET SourceBook to manage your code, you must make regular backups of your code databases. The best way to do this is to use your current backup process on every code database that you create or modify.

Total .NET SourceBook databases use the extension “.MDB”. The entire path of the database can be seen in the Code Explorer’s Information Section when you have the database selected in the treeview (by default, the FMS Code Database, FMSCode2.MDB is located in your My Documents folder).

Your code is invaluable. It represents a huge amount of time and effort, and should be backed up regularly.

Ensure that your code databases are part of a regular, automated backup routine. If you do not have a current backup process in place, consider using a tool that automates database maintenance on a scheduled basis, such as the FMS product Total Visual Agent. For more information, visit our web site at www.fmsinc.com.

See Also

  • Administrative Tools

  • Total .NET SourceBook Code Style

  • Adding Your Own Items

  • Editing and Deleting Items

  • Managing Multiple Code Databases

  • Searching Code Databases


Administrative Tools

Total .NET SourceBook includes a Database Maintenance form, which makes it easy to obtain information about code databases and to keep them compacted and repaired. To access the Database Maintenance form, choose Tools, Database Maintenance from the Code Explorer menu:

Database Maintenance Form

Note: Read The Importance of Backups for important information about backing up your databases.
Repair/Compact

In order to keep your code databases optimized and working properly, you should repair and compact them regularly. Click the “Repair/Compact” button, and browse to the location of the database. When the action is complete, you will see a notification message with a summary of the results:

Repair/Compact Summary Message

The Repair/Compact feature is an important tool for maintaining and optimizing your databases. You should determine how often to Repair/Compact your databases depending on how you use the product.

Be sure to Repair/Compact Code Databases when:

You move, add, or delete items

As you move, add, and delete items to Code Databases, they continue to grow without using space optimally. The Compact feature compresses your database to use space efficiently, increasing the speed and decreasing the storage space needed.

Your database becomes corrupt

If you have ever worked with Jet databases, you know that database corruption is a fact of life. If your database becomes corrupt, the Repair feature is vital in recovering your data.

If you rarely move, delete, and add items to your Code Databases, and you do not encounter database corruption, you may not need to run the repair/compact feature often.

Database Information

To obtain more information about a code database, press the “Information” button, and browse to the location of the code database:

Database Information Form

This form displays any users who are currently logged into the database, as well as the file size, date created, last write time, and last access time.

Note that the process used to check database information will appear in the Users Currently Logged Into the Database as another instance of your user on your machine. This means that at least one entry will be shown, even if no one else is accessing the database.

See Also

  • The Importance of Backups

  • Total .NET SourceBook Code Style

  • Adding Your Own Items

  • Editing and Deleting Items

  • Managing Multiple Code Databases

  • Searching Code Databases


Total .NET SourceBook Code Style

Every experienced programmer has his or her own ideas about what constitutes good programming style. While it is not possible for the code style used in Total .NET SourceBook to satisfy all developers, you can modify all of the code in the product to suit your own preferences.

See Also

  • The Importance of Backups

  • Administrative Tools

  • Exporting To and Importing From XML

  • Exporting To and Importing From a File

  • Adding Your Own Items

  • Editing and Deleting Items

  • Managing Multiple Code Databases

  • Searching Code Databases


Exporting To and Importing From XML

You can export any folder or code item to an XML file by using the File, Export SourceBook XML menu option (or the [image] item on the toolbar). This allows you to easily share your code items with other Total .NET SourceBook users.

To import a Total .NET SourceBook XML file, click on the database or folder where you want the new item to be saved. Then use the File, Import SourceBook XML menu option (or the [image] item on the toolbar).

See Also

  • The Importance of Backups

  • Administrative Tools

  • Total .NET SourceBook Code Style

  • Exporting To and Importing From a File

  • Adding Your Own Items

  • Editing and Deleting Items

  • Managing Multiple Code Databases

  • Searching Code Databases


Exporting To and Importing From a File

Exporting Code to a File

You can export any code item to a text file using the File, Export File menu item. The following form will appear:

Export File

Browse to the location where you want to save the file, and click “Next.”

The following form allows you to specify what items are exported:

Export File

This form shows a check box for each code tab that contains code. Select the languages that you want included in the file, and choose whether to include notes and other fields. Then, click “Next” to save the file.

Importing Code from a File

To import code from a file, click on the database or folder where you want the new item to be saved. Then use the File, Import File menu item, or right-click and choose Import File. The following form will appear:

File Import

Browse to the location of the file that you want to import, and click “Next.” The following form allows you to choose which code tab the file imports to:

File Import

Total .NET SourceBook reviews the contents of the file, and attempts to determine the code language. If it is incorrect, select the correct language from the list. If it is correct, click "Next," and the edit form opens for your new item, with the code on the appropriate tab.

See Also

  • The Importance of Backups

  • Administrative Tools

  • Total .NET SourceBook Code Style

  • Exporting To and Importing From XML

  • Adding Your Own Items

  • Editing and Deleting Items

  • Managing Multiple Code Databases

  • Searching Code Databases


Adding Your Own Items

Along with including an extensive code library, Total .NET SourceBook also acts as a repository for your own code. Using Total .NET SourceBook to manage your code allows you to:

· Stop hunting through old projects for code you know you’ve written.

· Keep track of useful articles and code snippets that you find online.

· Stop repeating work that you or your colleagues have already done.

· Know where the latest version of your code is stored.

· Add notes and copyright information to your code.

· Use the Code Explorer to organize your code.

· Use the Search tool to find code by keyword.

· Share your code with other Total .NET SourceBook users.

· Allow junior developers to learn from more experienced programmers’ code.

More Information

  • Adding New Databases

  • Adding New Folders

  • Adding New Items

    • Code Behind

    • Item Code

    • Item Notes

    • Item Details

See Also

  • The Importance of Backups

  • Administrative Tools

  • Total .NET SourceBook Code Style

  • Exporting To and Importing From XML

  • Exporting To and Importing From a File

  • Editing and Deleting Items

  • Managing Multiple Code Databases

  • Searching Code Databases


Adding New Databases

To add a new database, choose the File, New Database menu item (or click the [image] icon on the toolbar), and browse to your desired location:

Create New Database

A new code database is created, and is loaded in the treeview:

New Database in Treeview

Note: Read The Importance of Backups for important information about backing up your databases.

See Also

  • Adding Your Own Items

    • Adding New Folders

    • Adding New Items

  • Editing and Deleting Items

  • Managing Multiple Code Databases

  • Searching Code Databases


Adding New Folders

To add a new folder, select the database or folder where you want the new folder to be created. Then choose Edit, New Folder from the menu, use the [image] icon on the toolbar, or right-click and choose “New Folder.”

This opens the Item Editor:

Item Editor, Folder Tab

On the Folder tab, enter a name and description for the folder.

Folder Notes

Click “Notes” to display the folder’s Notes tab:

Item Editor, Notes Tab

On the Notes tab, you can enter a detailed description about the code included in the folder. The following formatting options are available from the Toolbar:

Set Font: Lets you set the font, style, and size of the text.

Set Font Color: Allows you to select the color of the text.

Bold: Applies or removes bold formatting.

Italic: Applies or removes italic formatting.

Underline: Applies or removes underlining.

Left Justify: Aligns the text to the left of the editor.

Center: Centers the text in the editor.

Right Justify: Aligns the text to the right of the editor.

Bullets: Applies or removes bullets.

Insert Image: Lets you browse to select an image to insert.

Note that storing images can significantly increase the size of your code database, and can adversely affect performance. Use this feature conservatively, and when images are necessary, choose store smaller image types (such as jpegs instead of bitmaps).

Folder Details

After entering your notes, click “Details” to view the Details tab:

Item Editor, Details Tab

This tab allows you to specify additional settings, such as author name, email, copyright information, source, and version. It also shows the creation and last modified dates for the folder.

The Name, Email, and Copyright Information fields are filled in automatically with the text specified in the Settings form (available from the Tools, Settings menu item). You can choose to keep the default values, or override them for individual items.

After you enter the desired folder information, click “OK” to save the new folder.

Note: Read The Importance of Backups for important information about backing up your databases.

See Also

  • Adding Your Own Items

    • Adding New Databases

    • Adding New Items

  • Editing and Deleting Items

  • Managing Multiple Code Databases

  • Searching Code Databases


Adding New Items

To add a new item, select the database or folder where you want the new item to be created. Choose Edit, New Item from the menu, use the [image] icon on the toolbar, or right-click and choose “New Item,” and the Item Editor for code items appears:

Item Editor, Code Tab

Enter a name and description for the new item. Then, choose the type of item from the “Item Type” list. The item type determines the icon that shows in the treeview.

Note: Read The Importance of Backups for important information about backing up your databases.

More Information

  • Code Behind

  • Item Code

  • Item Notes

  • Item Details

See Also

  • Adding Your Own Items

    • Adding New Databases

    • Adding New Folders

  • Editing and Deleting Items

  • Managing Multiple Code Databases

  • Searching Code Databases


Code Behind

In Visual Studio .NET 2005, Windows Forms and Web Forms are comprised of multiple related files (sibling items). Total .NET SourceBook allows you to link the related items using the “Code Behind” field.

For a Windows Form, create two Total .NET SourceBook items in the same folder: a WinForm item that contains the form code, and a Class that contains the designer code. Then edit the WinForm item, and select the designer code class in the “Code Behind” field.

For a Web Form, you will also create two Total .NET SourceBook items in the same folder: a WebForm item that contains the ASP.NET page’s HTML code, and a Class that contains the VB and/or C# code behind the page. Then edit the WebForm item, and select the code behind class in the “Code Behind” field.

This makes it easy to insert the form and its Code Behind class when using the Total .NET SourceBook Add-In.

More Information

  • Adding New Items

    • Item Code

    • Item Notes

    • Item Details

See Also

  • Adding Your Own Items

    • Adding New Databases

    • Adding New Folders

  • Editing and Deleting Items

  • Managing Multiple Code Databases

  • Searching Code Databases


Item Notes

After adding the item code, click “Notes” to display the Notes tab:

Item Editor, Notes Tab

Use the Notes tab to enter a detailed description of the item. The following formatting options are available from the Toolbar:

Set Font: Lets you set the font, style, and size of the text.

Set Font Color: Allows you to select the color of the text.

Bold: Applies or removes bold formatting.

Italic: Applies or removes italic formatting.

Underline: Applies or removes underlining.

Left Justify: Aligns the text to the left of the editor.

Center: Centers the text in the editor.

Right Justify: Aligns the text to the right of the editor.

Bullets: Applies or removes bullets.

Insert Image: Lets you browse to select an image to insert.

Note that storing images can significantly increase the size of your code database, and can adversely affect performance. Use this feature conservatively, and when images are necessary, choose store smaller image types (such as jpegs instead of bitmaps).

Note: Read The Importance of Backups for important information about backing up your databases.

More Information

  • Adding New Items

    • Code Behind

    • Item Code

    • Item Details

See Also

  • Adding Your Own Items

    • Adding New Databases

    • Adding New Folders

  • Editing and Deleting Items

  • Managing Multiple Code Databases

  • Searching Code Databases


Item Code

Enter the item’s code on the appropriate code tab. If you have copied your code onto the Windows Clipboard, use the Format/Paste from Clipboard button to place the code on the appropriate tab.

When you click the Format/Paste from Clipboard button, Total .NET SourceBook reviews the contents of the file, and makes an educated guess on the code language. It also fixes code indentations.

If Total .NET SourceBook’s “educated guess” is incorrect, choose the correct tab and press “Ctrl+V” to paste the code from your clipboard.

On the Code tab, right-click options are available to provide access to useful code options:

Undo/Redo | Undo or redo the last action performed.
Cut/Copy/ Paste | Cut, copy, and paste text to and from the Windows clipboard.
Select All | Select all text in the window.
Comment/ Uncomment | Comment or uncomment the selected line(s) of code.
Indent/ Outdent | Move the selected line(s) to the right or to the left, respectively.
Line Number | Display or hide line numbers. This option is reset each time the application starts.
Bookmarks | Add, remove, and navigate bookmarks. Bookmarks are cleared when you change views.
Outlining | Outline code by expanding/collapsing sections. Outlining is reset when you switch views.
Print/Print Preview | Print the contents of the current tab directly, or preview the code printout.
Find/Replace | Find, mark, and optionally replace a word or phrase.
Go to… | Quickly jump to a specific line number.
Highlighting Style Editor | Customize the display by setting font colors and styles. The style is reset when you switch views.
Edit | Open the item in edit mode.

Note: Read The Importance of Backups for important information about backing up your databases.

More Information

  • Adding New Items

    • Code Behind

    • Item Notes

    • Item Details

See Also

  • Adding Your Own Items

    • Adding New Databases

    • Adding New Folders

  • Editing and Deleting Items

  • Managing Multiple Code Databases

  • Searching Code Databases


Item Details

After entering the notes, click “Details” to move to the Details tab:

Item Editor, Details Tab

This tab allows you to specify additional settings, such as author name, email, copyright information, source, and version. It also shows the creation and last modified dates for the folder. After entering the desired information, click “OK” to save the new item.

The values on this form default to the values you entered when Configuring Settings.

More Information

  • Adding New Items

    • Code Behind

    • Item Code

    • Item Notes

See Also

  • Adding Your Own Items

    • Adding New Databases

    • Adding New Folders

  • Editing and Deleting Items

  • Managing Multiple Code Databases

  • Searching Code Databases


Editing and Deleting Items

You can edit any existing folder or code item. To edit a folder or item, select it in the treeview and choose Edit, Edit Item (or click on the [image] icon on the toolbar). The Item Editor appears, allowing you to change the code, notes, or details. The options available on the Item Editor are identical to the options available when you add a new folder or a new item.

To delete a folder or code item, simply choose Edit, Delete Item from the menu, or click on the [image] icon on the toolbar. The item is permanently deleted, and cannot be recovered.

See Also

  • The Importance of Backups

  • Administrative Tools

  • Adding Your Own Items

  • Managing Multiple Code Databases

  • Searching Code Databases


Managing Multiple Code Databases

Total .NET SourceBook provides the flexibility to manage tasks and share code resources with other developers by making it possible to create multiple code databases. For example you may want to keep your own code separate from the FMS code that is included in Total .NET SourceBook. Or you may want to create a separate code database for each project that you’re working on, and only see the code for one project at a time.

Is very important to make regular backups of every code database that you use.

Creating a Database

To add a new database, choose the File, New Database menu item (or click the [image] icon on the toolbar), and browse to your desired location.

Opening an Existing Database

To open a Total .NET SourceBook database that already exists, choose File, Open Database from the menu (or click the [image] icon on the toolbar). Browse to the location of the existing database, and click OK. The database and its code now appear in the treeview.

Closing a Database

If you no longer want to see a particular code database in the Total .NET SourceBook treeview, you can close the database. Simply choose File, Close Database from the menu, or click on the [image] icon on the toolbar.

Closing a database does not delete the database—it still exists in the location where it was created. You can reopen the database at any time by choosing File, Open Database from the menu.

Maintaining Databases

Total .NET SourceBook stores code in Jet Engine database files. Just like any other Jet databases, they need to be periodically repaired and compacted to maintain integrity and efficiency.

See Also

  • The Importance of Backups

  • Administrative Tools

  • Adding Your Own Items

  • Editing and Deleting Items

  • Searching Code Databases


Searching Code Databases

Although the Code Explorer treeview makes it easy to locate code by category, there will no doubt be times when you can’t find what you’re looking for. The Code Explorer includes a powerful search tool that allows you to search for code by language, code type, and database.

Choose Search, Local Database(s) from the menu, click on the [image] icon on your toolbar, or use the keyboard shortcut Crtl+F to show the Advanced Search form:

Search Tool

The Advanced Search tool allows you to search with the following options:

· Match Case: Make your search case-sensitive.

· Partial Match/Match Entire Field: Use the Partial Match option to find the search string anywhere in the field. Use the Match Entire Field option if you know the entire contents of the field.

· Language Filter: Select which language tabs to search.

· Type Filter: Select which code types to search.

· Version Filter: Select which versions of code to search.

As a shortcut, right-click in a filter field and choose “Select All” or “Clear All” to select or clear all check boxes in the current field.

Search results are displayed at the bottom of the Code Explorer.

See Also

  • The Importance of Backups

  • Administrative Tools

  • Adding Your Own Items

  • Editing and Deleting Items

  • Managing Multiple Code Databases


Launching the Add-In

Total .NET SourceBook is designed to be simple enough to use every time you use Visual Studio .NET, without interfering with other parts of your IDE. The product’s features are organized into toolwindows that can be docked or undocked and shown or hidden just like any Visual Studio .NET toolwindow.

When you install Total .NET SourceBook and run Visual Studio .NET, the add-in is automatically loaded into the IDE and the Total .NET SourceBook Navigator toolwindow appears. With this default behavior, you do not need to open or start the product—it is automatically loaded whenever you start Visual Studio .NET.

If the toolwindow does not open when you start Visual Studio .NET, one of the following conditions may be true:

  1. The toolwindow was explicitly closed (using the [X] close button).

  2. The product’s add-in load status has been changed from its default value of “Startup”.

If the toolwindow is not open, select Tools, FMS Total .NET Suite, Total .NET SourceBook, Show Window from the Visual Studio .NET menu:

Show Total .NET SourceBook Window

See Also

  • Changing Add-In Settings

  • Add-In Toolwindows
  • Editing Item Properties
  • Getting Code into Your Project
  • Getting Code into Total .NET SourceBook


Changing Add-In Settings

Total .NET SourceBook is implemented as an add-in to Visual Studio .NET. You can change the program’s load behavior by using the Visual Studio .NET add-in manager. To open this manager, select Tools, Add-In Manager from the Visual Studio .NET menu.

Visual Studio .NET Add-in Manager

To load Total .NET SourceBook every time you start Visual Studio .NET, check the Startup checkbox. If you want to load Total .NET SourceBook manually instead, uncheck Startup.

See Also

  • Launching the Add-In

  • Add-In Toolwindows
  • Editing Item Properties
  • Getting Code into Your Project
  • Getting Code into Total .NET SourceBook


Add-In Toolwindows

The Total .NET SourceBook Add-In is comprised of a set of toolwindows, including:

  • Navigator Toolwindow
  • Item Preview Toolwindow
  • Item Notes Toolwindow
  • Search SourceBook Results Toolwindow

These toolwindows behave the same as all built-in Visual Studio .NET toolwindows. They can be moved, docked/undocked, hidden/pinned, and resized as desired.

The first time you start Visual Studio .NET after installing Total .NET SourceBook, the Navigator toolwindow appears in undocked mode. Use the buttons on the Navigator toolwindow to view the other toolwindows.

See Also

  • Launching the Add-In

  • Changing Add-In Settings

  • Editing Item Properties
  • Getting Code into Your Project
  • Getting Code into Total .NET SourceBook


Navigator Toolwindow

When the Total .NET SourceBook Add-In is loaded, the SourceBook Navigator toolwindow appears:

Navigator Toolwindow

By default, the toolwindow shows the FMSCode2.mdb database that is loaded in the Code Explorer. If FMSCode2.mdb is not loaded in the Code Explorer, the toolwindow shows the last code database that was opened through the Code Explorer.

The Navigator treeview allows you to view, edit, delete, and search for code items and notes. It also allows you to export code directly into your Visual Studio .NET project.

Total .NET SourceBook does not allow you to create, open, or close code databases in Add-In mode. Use the Code Explorer to create, open, or close code databases.

After creating, opening, or closing code databases, you must close the Code Explorer, and refresh the Add-In to reload the last code database that you opened.

Toolbar Items

The main toolbar contains shortcuts for top-level functionality:

Navigator Toolbar

Action | Description
View Code | Opens the SourceBook Item Preview toolwindow for viewing and editing code.
View Notes | Opens the SourceBook Item Notes toolwindow for viewing and editing notes.
Refresh | Refreshes the treeview to get the latest version and keep it in sync with the Code Explorer.
Expand All | Expands treeview nodes to show all code.
Collapse All | Collapses treeview nodes.
Find Text/Go | Performs a search for the specified text, and shows the results in the Search Results toolwindow. Note that this is a simple string search. The Code Explorer includes an Advanced Search tool with additional options.
Insert in Project | Pastes the code from the SourceBook Item Preview into your project at the cursor location. If no file is open in Visual Studio, a new file is created in your project.
Code Treeview

The code treeview shows the code database that is loaded, with icons to differentiate between item types. The treeview offers the following options for viewing and organizing code:

View code and notes
Highlight the item in the treeview, and click the View Code [image] or View Notes [image] button on the toolbar (or right-click and choose View Code or View Notes).

Delete items
Right-click on the item, and choose Delete Item from the menu.

Move and copy code items
Click on an item and drag it into the desired location.

Paste the code into your project
Highlight the item in the treeview, and click the Insert [image] button on the toolbar.

See Also

  • Add-In Toolwindows
    • Item Preview Toolwindow
    • Item Notes Toolwindow
    • Search SourceBook Results Toolwindow
  • Editing Item Properties
  • Getting Code into Your Project
  • Getting Code into Total .NET SourceBook


Item Preview Toolwindow

When you click the View Code [image] button from the SourceBook Navigator toolwindow, the SourceBook Item Preview toolwindow appears:

SourceBook Item Preview Toolwindow

This toolwindow shows the code for the item that you have highlighted in the Code treeview (in the SourceBook Navigator toolwindow). From this toolwindow, you can add new code, or review and edit existing code. You can also add the code directly to your project.

The Item Preview toolwindow has the same right-click options available as the Code Explorer.

Right-Click Context Menu

Right-click on the Item Preview toolwindow to access several useful code options, including:

· Copy | · Select All
· Outlining | · Bookmarks
· Print | · Print Preview
· Find/Replace | · Go To…
· Highlighting Style Editor | · Insert in Project

These menu options are similar to those available when editing code through the Code Explorer. The only exception is the Insert Code option, which allows you to add the code directly to your project.

Code Tabs

The code tabs appear below the information section:

Item Preview Toolwindow, Code Tabs

The code tabs display the item’s code, and allow you to organize your code by language. Tabs containing code are displayed with the [image] icon, so you can easily identify where your code is stored.

See Also

  • Add-In Toolwindows
    • Navigator Toolwindow
    • Item Notes Toolwindow
    • Search SourceBook Results Toolwindow
  • Editing Item Properties
  • Getting Code into Your Project
  • Getting Code into Total .NET SourceBook


Item Notes Toolwindow

When you click the View Notes [image] button on the Navigator toolwindow, the Item Notes toolwindow appears:

SourceBook Item Notes Toolwindow

This toolwindow shows the notes for the item that you have highlighted in the Code treeview (in the Navigator toolwindow). From this toolwindow, you can add new notes, or review and edit existing notes.

The following formatting options are available on the Toolbar:

Set Font: Lets you set the font, style, and size of the text.

Set Font Color: Allows you to select the color of the text.

Bold: Applies or removes bold formatting.

Italic: Applies or removes italic formatting.

Underline: Applies or removes underlining.

Left Justify: Aligns the text to the left of the editor.

Center: Centers the text in the editor.

Right Justify: Aligns the text to the right of the editor.

Bullets: Applies or removes bullets.

Insert Image: Lets you browse to select an image to insert.

Note that storing images can significantly increase the size of your code database, and can adversely affect performance. Use this feature conservatively, and when images are necessary, choose store smaller image types (such as jpegs instead of bitmaps).

See Also

  • Add-In Toolwindows
    • Navigator Toolwindow
    • Item Preview Toolwindow
    • Search SourceBook Results Toolwindow
  • Editing Item Properties
  • Getting Code into Your Project
  • Getting Code into Total .NET SourceBook


Search SourceBook Results Toolwindow

When you perform a search from the Navigator toolwindow, the SourceBook Search Results toolwindow appears:

SourceBook Search Results Toolwindow

Click on an item in the Search Results window, and the Navigator toolwindow jumps to that item.

See Also

  • Add-In Toolwindows
    • Navigator Toolwindow
    • Item Preview Toolwindow
    • Item Notes Toolwindow
  • Editing Item Properties
  • Getting Code into Your Project
  • Getting Code into Total .NET SourceBook


Editing Item Properties

You can edit code properties using the Visual Studio .NET Properties window. Simply view the properties window (choose View, Properties Window from the Visual Studio .NET menu), and highlight an item in the Navigator toolwindow treeview. The properties window shows all configurable properties for the item:

Properties Window

See Also

  • Add-In Toolwindows
  • Getting Code into Your Project
  • Getting Code into Total .NET SourceBook


Getting Code into Your Project

The Total .NET SourceBook Add-in makes it easy to copy code snippets, code items, and entire folders from your Code Database into a Visual Studio .NET project.

The following options are available for getting code from Total .NET SourceBook into your project:

Insert Code from the Navigator Toolwindow

Total .NET SourceBook allows you to insert entire folders, or individual items from the Navigator Toolwindow.

You cannot insert code form the Navigator Toolwindow into a Web Application. To insert code into Web Applications, use the "Insert Code" option available from the Item Preview toolwindow (explained below).

Inserting Entire Folders

Total .NET SourceBook folders are used to organize related items in a Code Database. The Add-In lets you insert all items in a folder at once. Simply select the folder in the SourceBook Navigator Toolwindow, and click the “Insert in Project” button: .

A new file is created in your project for each code item in the Total .NET SourceBook folder, with the appropriate code language (depending on the project type you are working on). Any forms that have sibling classes linked (Code Behind) are automatically associated in Visual Studio .NET.

Note that subfolders and items contained in subfolders are not inserted in the project.

Inserting Individual Items

To insert an individual code item in your project, select the item in the SourceBook Navigator Toolwindow, and click the “Insert in Project” button: . If a file is open in Visual Studio .NET, the appropriate language of the code is inserted at the cursor location. If no file is open in Visual Studio .NET, a new file is created for the item.

Insert Code from the Item Preview Toolwindow

To insert code from the Item Preview toolwindow, first open the Visual Studio .NET file where you want to insert the code. Then right-click on the Item Preview toolwindow’s code tab, and choose “Insert Code”: The code is inserted into your file at the location of the cursor.

Additionally, you can highlight a piece of code in the Item Preview toolwindow, hold the “Ctrl” button down, and drag the code into your file. Make sure to hold the “Ctrl” button down—if you don’t, the code is moved (not copied) into your file, and it’s removed from Total .NET SourceBook.

See Also

  • Add-In Toolwindows
  • Editing Item Properties
  • Getting Code into Total .NET SourceBook


Getting Code into Total .NET SourceBook

Total .NET SourceBook makes it easy to store your own items by letting you drag and drop code from Visual Studio .NET directly into the code database. You can drag selected code from the editor, or entire code files from the solution explorer.

Dragging Code from the Editor

To drag code into the Item Preview toolwindow, simply highlight it in the editor, and drag it into the Navigator Toolwindow's treeview. A new item appears in the treeview with the name “Copied from Visual Studio Editor”:

Item Dragged to Treeview

To change the name, edit the item properties.

Dragging Code from the Solution Explorer

To drag entire code files (classes, modules, etc.) into Total .NET SourceBook, locate the code file in the Solution Explorer, and drag it into the Navigator Toolwindow treeview. The item name matches the name of the Visual Studio .NET object, and it can be changed by editing the item properties.

See Also

  • Add-In Toolwindows
  • Editing Item Properties
  • Getting Code into Your Project


Code Webservice Overview

FMS regularly releases new code to Total .NET SourceBook Code Webservice subscribers through the unique Code Webservice. Every time you start the Code Explorer, a process runs in the background to connect to the Webservice. Users with an active Webservice subscription can download the latest code, articles, and tips. You can even post your own items to share with other subscribers.

Note that you must have an active Internet connection in order to contact the Code Webservice. If you have a high-speed connection, this process is relatively fast. If you have a slower connection, the process will take a little more time.

Because the process runs in the background, however, you can start using Total .NET SourceBook right away, without waiting for the connection to be established.

Once a connection is established, Total .NET SourceBook queries the Webservice and returns a list of new code available since your last download. This list is displayed the Start Page:

New Code Webservice Content

This list shows only items that are new since the last time you downloaded content. If you need to retrieve old content, reset the Code Webservice date.

Code Webservice Subscriptions

The FMS Code Webservice subscription is available on an annual basis. FMS developers regularly post new code, tips, and articles that are available exclusively to Code Webservice subscribers. Keep your subscription up-to-date by contacting FMS Customer Service.

See Also

  • Privacy and Security Notice

  • Downloading Code

  • Organizing the Code

  • Retrieving Earlier Webservice Content

  • Sharing Your Code

  • Troubleshooting Code Webservice Errors


Downloading Code

Downloading Code from the Webservice

To import the latest code, click “Download New Content” from the Start page, choose Search, Code Webservice from the menu, or click on the [image] icon on the toolbar. A preview form appears with the name, description, date, and size of each item in the Webservice:

Import from Code Webservice

After reviewing the items available, click the Download all new content button to add all items to your database.

When you click the Download all new content button, all items are downloaded. The Webservice does not allow you to download only a subset of the available items. Keep in mind, however, that you can always delete unwanted items from the Code Database after they are downloaded.

When the download is complete, the Download Status field updates with the location of the content:

Webservice Download Complete

If there were errors during the process, they are also listed in this field.

When you download content from the Code Webservice, it is automatically placed in the Code Database that appears first in the Code Explorer treeview. After downloading the code, you should generally review it and move or copy it to an appropriate location.

See Also

  • Code Webservice Overview

  • Privacy and Security Notice

  • Organizing the Code

  • Retrieving Earlier Webservice Content

  • Sharing Your Code

  • Troubleshooting Code Webservice Errors


Organizing the Code

Organizing Code from the Webservice

When you download code from the Webservice, it is added to the Code Database that appears first in the Code Explorer treeview. For instance, in the following example, the content would be downloaded to the database named “Alison’sCode.mdb” since it appears first in the list:

Treeview Example

Within that Code Database, Total .NET SourceBook creates a folder named “FMS Code Webservice Downloaded”, and within that folder, Total .NET SourceBook creates a subfolder with the download date. The downloaded code items are added to that subfolder:

Webservice Download Treeview Structure

In general, you will want to review the downloaded content and move it to an appropriate location. Just like any other item in the treeview, downloaded items can be moved, renamed, edited, or deleted.

See Also

  • Code Webservice Overview

  • Privacy and Security Notice

  • Downloading Code

  • Retrieving Earlier Webservice Content

  • Sharing Your Code

  • Troubleshooting Code Webservice Errors


Retrieving Earlier Webservice Content

When you download code from the Webservice, Total .NET SourceBook records the date. This keeps you from seeing code that you have already downloaded and from getting the same code multiple times. The items that show on the Start Page are items that are new since the last time you downloaded from the Webservice.

There may be times, however, when you need to reset this date to retrieve earlier content. For instance, if you inadvertently remove downloaded code, you may want to download it again. If for any reason you want to access code that you have already downloaded, you will need to change the Webservice date. To do this, choose Tools, Settings from the menu, and change the date on the Web Service tab:

Reset Code Webservice Date

See Also

  • Code Webservice Overview

  • Privacy and Security Notice

  • Downloading Code

  • Organizing the Code

  • Sharing Your Code

  • Troubleshooting Code Webservice Errors


Sharing Your Code

The Total .NET SourceBook Code Webservice subscription includes a service that integrates with your MyFMS user ID and the Total .NET SourceBook Code Webservice. This service offers the ability to upload your own code for other Code Webservice subscribers to download. Simply export your code from Total .NET SourceBook to .XML format, and upload it through our web interface to share it with other Code Webservice users.

The code you submitted and your MyFMS user name, shows in the Total .NET SourceBook Start Page, and can be downloaded by all Code Webservice subscribers.

Visit www.fmsinc.com/dotnet/SourceBook/, and click “Share your Code.”

See Also

  • Code Webservice Overview

  • Privacy and Security Notice

  • Downloading Code

  • Organizing the Code

  • Retrieving Earlier Webservice Content

  • Troubleshooting Code Webservice Errors


Troubleshooting Code Webservice Errors

If Total .NET SourceBook encounters an error connecting to the Webservice or downloading content, an error message is displayed in the Code Webservice Dialog:

Webservice Error

Below is a list of common error conditions and how to solve them:

Error Condition | Resolution
Could not connect to the FMS Code Webservice. Please ensure you have a valid connection to the internet and try again. | Please verify that you have an active connection to the Internet.
You are not subscribed to the Code Webservice. | Your subscription to the Code Webservice was not activated, or has expired. Please contact FMS Customer Service to subscribe to the Code Webservice.
The FMS Code Webservice is down for maintenance. Please try again later. | Try contacting the FMS Code Webservice at a later time.
Could not connect to the FMS Code Webservice. Your product installation is invalid. (Error 0010, 0011, 0012, or 0013). | Please contact: support@fmsinc.com

If the suggestions listed above do not resolve your issue or you are receiving an error not listed here, please contact our Technical Support department at support@fmsinc.com.

See Also

  • Code Webservice Overview

  • Privacy and Security Notice

  • Downloading Code

  • Organizing the Code

  • Retrieving Earlier Webservice Content

  • Sharing Your Code


Support Resources

There are many resources available to help you resolve issues you may encounter. Please check the following:

Readme File

Check the README file for the latest product information. The README file is located in the directory where you installed the product.

Product Documentation

We’ve spent a great deal of care and time to make sure the Total .NET SourceBook manual and help file are very detailed. Check the Table of Contents and Index for your question, and read the appropriate pages.

See Also

  • Web Site Support

  • Technical Support Options

  • Contacting Technical Support

  • Troubleshooting Code Webservice Errors


Web Site Support

The FMS web site contains extensive resources to help you use our products better. Resources include product updates, frequently asked questions (FAQs), newsgroups, information on new versions, betas, and other resources.

Web Site

The FMS web site is located at:

www.fmsinc.com

News and important announcements are posted here.

Support Site

The main support page is located at:

www.fmsinc.com/support

From this page, you can quickly locate the other support resources.

Product Updates

FMS takes product quality very seriously. When bugs are reported and we can fix them, we make the updates available on our web site. If you are encountering problems with our product, make sure you are using the latest version by checking:

www.fmsinc.com/support/

Frequently Asked Questions (FAQs)

Common questions and additional information beyond what is in the manual is often available from our FAQs.

Newsgroups

FMS also has general and product specific newsgroups. Connect with FMS Technical Support and other users there. Share your experiences, learn from others, and ask your questions in our virtual community:

www.fmsinc.com/support/newsgrp.htm

Or visit our web site for additional information.

Microsoft Patches

Our support site also includes links to Microsoft patches that are related to our products. Make sure you’re using the latest versions by checking here or visiting the Microsoft site:

www.microsoft.com

See Also

  • Support Resources

  • Technical Support Options

  • Contacting Technical Support

  • Troubleshooting Code Webservice Errors


Technical Support Options

FMS is committed to providing professional support for all of our products. We offer free access to our online FAQs and newsgroups. Bug reports, feature requests, suggestions, and general pre-sales questions related to our products are always available at no cost.

Additional maintenance plans are available to provide subscribers with enhanced technical support. This is the best way for you to stay current with the rapidly changing technologies that impact project development, and to ensure you are getting the maximum return from your software investment. Please visit our web site, www.fmsinc.com, for the most up-to-date information.

Features & Benefits

Premium

Incident

Standard

Access to FAQs

Access to Newsgroups

Minor Upgrades/
Bug Fixes

Telephone Support

Per incident

First 30 Days

Email Support

Per incident

First 30 Days

Priority Response Time 1

Senior Engineer Support Team

Email Project for Testing

Programmatic Code Assistance 2

Major Upgrades for Current Version

Additional fee

Additional fee

Cost

Annual Fee

Fee Per Incident

Included

1. Response generally within two business days. Actual resolution may take longer depending on complexity of the issue reported.

2. Custom Programming implementation is not provided in our Support Maintenance plans. For products that include a programmatic interface, we can provide instructions for using our programmatic interface, and show examples, but we do not implement this into your projects. This service is available from our Professional Solutions Group.

Premium Subscription

The Premium Subscription is the ideal option for customers seeking the highest level of support from FMS. The annual fee entitles you to telephone and email technical support from a senior support engineer.

From time to time, FMS may release new versions of existing products which add new features. These are point releases (e.g. from version 2.0 to 2.1) and are different from new builds that correct problems in existing features (e.g. from version 2.0.0.1 to 2.0.0.2).

These point releases are available for a nominal upgrade fee to existing customers. Premium Technical Support subscribers receive these upgrades automatically and for no additional charge during their subscription term.

NOTE: Upgrades between versions of Visual Studio .NET are not considered Point Release Upgrades and are not included in the Premium Subscription.

Subscriptions are available for a twelve month period, and may be purchased at any time. You must be the registered owner of the product to purchase a subscription and the only person contacting FMS for support under the subscription.

Please ensure you have purchased the Subscription you need for Total .NET SourceBook.

Per Incident

Our Per Incident package is available individually or by purchasing multiple incidents in advance. The Per Incident support package provides telephone and email technical support from a Senior Technical Support Engineer for resolving one incident.

An incident is defined as a single question related to one of our products. The Per Incident period is from start to finish (report of the incident to resolution) for a single incident. If you anticipate multiple questions for a single product, we recommend purchasing the Premium Subscription.

Standard Subscription

Our Standard Subscription comes with every product purchased for no additional cost. The standard subscription comes with access to our FAQs and newsgroups, and responses to bug reports and feature requests for that version.

Please note that the person requesting support must also be the registered user of the product. Registration is required and will be requested by our Technical Support professionals.

See Also

  • Support Resources

  • Web Site Support

  • Contacting Technical Support

  • Troubleshooting Code Webservice Errors


Contacting Technical Support

If the troubleshooting suggestions and other support resources fail to resolve your problem, please contact our technical support department. We are very interested in making sure you are satisfied with our product.

Registering Your Software

Please register your copy of Total .NET SourceBook at:

www.fmsinc.com/support

You must be registered to receive technical support. Registration also entitles you to free product updates, notifications, information about upcoming products, and beta invitations. You can even receive free email notification of our latest news.

Contact Us

The best way to contact us is via email at:

Support@fmsinc.com

Please provide detailed information about the problem that you are encountering. This should include the name and version of the product, your operating system, and the specific problem. If the product generated an error file, please submit that as well.

With email, technical support issues can be more accurately resolved and tracked in our internal technical support system. Email also gives us more time to understand the entire problem and allows our technical support staff to contact the developers with the entire story when necessary. Please bear in mind that a unique issue may involve meetings between the technical support staff and product developers, so your patience is appreciated.

Microsoft Technical Support

FMS only provides technical support for its products. If you have questions regarding Microsoft products, please contact Microsoft technical support.

See Also

  • Support Resources

  • Web Site Support

  • Technical Support Options

  • Troubleshooting Code Webservice Errors


License Agreement

PLEASE READ THE FMS SOFTWARE LICENSE AGREEMENT. YOU MUST AGREE TO BE BOUND BY THE TERMS OF THIS AGREEMENT BEFORE YOU CAN INSTALL OR USE THE SOFTWARE.

IF YOU DO NOT ACCEPT THE TERMS OF THE LICENSE AGREEMENT FOR THIS OR ANY FMS SOFTWARE PRODUCT, YOU MAY NOT INSTALL OR USE THE SOFTWARE. YOU SHOULD PROMPTLY RETURN ANY FMS SOFTWARE PRODUCT FOR WHICH YOU ARE UNWILLING OR UNABLE TO AGREE TO THE TERMS OF THE FMS SOFTWARE LICENSE AGREEMENT FOR A REFUND OF THE PURCHASE PRICE.

Ownership of the Software

The enclosed software program (“SOFTWARE”) and the accompanying written materials are owned by FMS, Inc. or its suppliers and are protected by United States copyright laws, by laws of other nations, and by international treaties. You must treat the SOFTWARE like any other copyrighted material except that you may make one copy of the SOFTWARE solely for backup or archival purpose, and you may transfer the SOFTWARE to a permanent storage device.

Grant of License

The SOFTWARE is available in a single user license version. You may purchase additional licenses by contacting FMS, Inc.

For each license purchased, you are permitted (either as an individual, or if an entity, one designated individual) to use the program on one computer at a time.

Redistributable Components

Only the Library Code included in the SOFTWARE may be redistributed. Library Code is defined as the programming code that is available when using the SOFTWARE program’s Code Explorer interface. You are specifically prohibited from redistributing any other file or part of the SOFTWARE.

Use and Redistribution Rights

FMS grants you the right to distribute the Library Code on a non-exclusive, royalty free basis, provided that:

1. Each developer using the program or the source code from the program owns a license of the SOFTWARE.

2. You do not distribute the library code, in whole or in part, in any form that does not add primary and substantial value to the library code.

3. You do not distribute the library code in an application that is similar in nature or purpose to the SOFTWARE.

4. You agree to indemnify, hold harmless, and defend FMS and its suppliers or contractors from and against any claims or lawsuits, including attorneys’ fees that arise or result from the use or distribution of or other activities relating to your software.

5. If you claim a copyright, you must add a clause stating “Portions of this program are Copyright Total .NET SourceBook from FMS, Inc.” and that you do not claim ownership of the SOFTWARE.

Publishing Library Code

You are prohibited from publishing library code on any medium, including, but not limited to, electronic mail, online services, internet newsgroups, and printed matter, except when library code is distributed in an application that adds substantial value to the library code and that application is not similar in nature or purpose to the SOFTWARE.

The Library Code may not be included in freeware or shareware applications in a non-compiled state.

Code Webservice – Information Collected by FMS

When you access the FMS Code Webservice, certain data from your computer is sent to FMS for the sole purpose of verifying your SOFTWARE license. This information includes your computer name, your registered user name and organization, and your serial number. The data collected is used only for license verification purposes, and is not distributed outside of FMS.

Restrictions

You may not reverse engineer, de-compile, or disassemble this SOFTWARE. The SOFTWARE is licensed as a single product and may not be separated by use for more than one user at a time. You may not rent or lease the SOFTWARE. You may not transfer any of your rights under the FMS Software License Agreement to other individuals or entities. Without prejudice to any other rights, FMS may terminate this FMS Software License Agreement at any time if you fail to comply with any of its terms. In such an event of termination, you must destroy and stop using all affected SOFTWARE copies.

Transfer of License

If your SOFTWARE is marked “NOT FOR RESALE,” you may not sell or resell the SOFTWARE, nor may you transfer the FMS Software license.

If your SOFTWARE is not marked “NOT FOR RESALE,” you may transfer your license of the SOFTWARE to another user or entity provided that:

1. You have not used any of the library code in an application.

2. The recipient agrees to all terms of the FMS Software License Agreement.

3. You provide all original materials including software disks or compact disks, and any other part of the SOFTWARE’s physical distribution to the recipient.

4. You remove all installations of the SOFTWARE.

5. You notify FMS, in writing, of the ownership transfer.

Technical Support on Library Code

Because of the complexity of software development, FMS does not provide technical support related to the use of the Library code in your applications. Technical support is available for issues you find on the Code Explorer application and issues with the included Library Code and associated documentation.

Limited Warranty

If you discover physical defects in the media on which this SOFTWARE is distributed, or in the related manual, FMS, Inc. will replace the media or manual at no charge to you, provided you return the item(s) within 60 days after purchase.

ALL IMPLIED WARRANTIES ON THE MEDIA AND MANUAL, INCLUDING IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE LIMITED TO SIXTY (60) DAYS FROM THE DATE OF PURCHASE OF THIS PRODUCT.

Although FMS, Inc. has tested this program and reviewed the documentation, FMS, Inc. makes no warranty or representation, either expressed or implied, with respect to this SOFTWARE, its quality, performance, merchantability, or fitness for a particular purpose. As a result, this SOFTWARE is licensed “AS-IS”, and you are assuming the entire risk as to its quality and performance.

IN NO EVENT WILL FMS, INC. BE LIABLE FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES RESULTING FROM THE USE, OR INABILITY TO USE THIS SOFTWARE OR ITS DOCUMENTATION. THE WARRANTY AND REMEDIES SET FORTH IN THIS LIMITED WARRANTY ARE EXCLUSIVE AND IN LIEU OF ALL OTHERS, ORAL OR WRITTEN, EXPRESSED OR IMPLIED.

Some states do not allow the exclusion or limitation of implied warrantees or liability for incidental or consequential damages, so the above limitations or exclusions may not apply to you. This warranty gives you specific legal rights; you may also have other rights that vary from state to state.

U.S. Government Restricted Rights

The SOFTWARE and documentation are provided with RESTRICTED RIGHTS. Use, duplication, or disclosure by the Government is subject to restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in Technical Data and Computer Software clause at DFARS 252.227-7013 or subparagraphs (c) (1) and (2) of the Commercial Computer Software - Restricted Rights at 48 CFR 52.227-19, as applicable.

Manufacturer is FMS Inc., Vienna, Virginia.
Printed in the USA.

Total .NET SourceBook is copyright Ó 1996-2006 by Financial Modeling Specialists, Inc.
All rights reserved.
Microsoft, Windows, Visual Studio .NET, Visual Basic, C#, and VB are registered trademarks of Microsoft Corporation.
All other trademarks are trademarks of their respective owners.


Privacy and Security Notice

When you access the FMS Code Webservice, certain data from your computer is sent to FMS for the sole purpose of verifying your SOFTWARE license. This information includes your computer name, your registered user name and organization, and your serial number. The data collected is used only for license verification purposes, and is not distributed outside of FMS.